/*
 * BrowserDisplayConstants.java
 */


package com.trapezium.browser;

import java.awt.Color;
import java.awt.Font;

/** Global predefined display info */
public interface BrowserDisplayConstants {

    // default values
    final static int LEFT_MARGIN = 8;
    final static int TOP_MARGIN = 4;
    final static int RIGHT_MARGIN = 8;
    final static int BOTTOM_MARGIN = 4;
    final static int HGAP = 5;
    final static int VGAP = 5;

    // border styles
    static final int LOWERED_BORDER = -1;
    static final int NO_BORDER = 0;
    static final int THIN_BORDER = 1;
    static final int RAISED_BORDER = 2;
    static final int FRAMED_BORDER = 3;
    static final int THICK_BORDER = 4;

    final static Color DEFAULT_TABLECOLOR = new Color(179, 167, 148);
	final static Color DEFAULT_FRAMECOLOR = new Color(153, 204, 204);
	final static Color DEFAULT_ROWHEADERCOLOR = new Color(102, 55, 27);
	final static Color DEFAULT_PANECOLOR = Color.lightGray;
	final static Color DEFAULT_WORKSPACECOLOR = DEFAULT_FRAMECOLOR.darker();
	final static Color DEFAULT_ACTIVECOLOR = new Color(0, 0, 204);
	final static Color DEFAULT_INACTIVECOLOR = Color.blue.darker().darker();
	final static Color DEFAULT_SELECTEDCOLOR = Color.yellow;
	final static Color DEFAULT_SELECTEDTEXTCOLOR = Color.magenta.darker();
	final static Color DEFAULT_BGCOLOR = new Color(255, 255, 255);
	final static Color DEFAULT_TEXTCOLOR = Color.black;
	final static Color DEFAULT_FADEDTEXTCOLOR = Color.darkGray;
	final static Color DEFAULT_TITLETEXTCOLOR = Color.white;
	final static Color DEFAULT_BORDERCOLOR = Color.black;
	final static Color DEFAULT_SHADOWCOLOR = Color.darkGray;
	final static Color DEFAULT_LITESHADOWCOLOR = Color.lightGray;
	final static Color DEFAULT_RULECOLOR = Color.cyan.brighter();
	//final static Color DEFAULT_TOOLBARCOLOR = new Color(153, 170, 170);
	//final static Color DEFAULT_STATUSBARCOLOR = DEFAULT_TOOLBARCOLOR;
	final static Color DEFAULT_PROGRESSBARCOLOR = new Color( 102, 204, 102 );
    final static Color DEFAULT_CONTROLCOLOR = new Color(102, 153, 128);
    final static Color DEFAULT_GROOVECOLOR = new Color(102, 102, 102);
    final static Color DEFAULT_TOPTABLECOLOR = new Color(204, 204, 204); //new Color(123, 184, 225);
    final static Color DEFAULT_TOOLTIPCOLOR = new Color(255, 255, 153);
    final static Color DEFAULT_POPUPCOLOR = new Color(204, 187, 153);
    final static Color DEFAULT_POPUPTEXTCOLOR = Color.black;


    final static String DEFAULT_TILE = "tile.jpg";
    final static int DEFAULT_TILEX = -10;      // Netscape default left margin is 10
    final static int DEFAULT_TILEY = -15;      // Netscape default top margin is 15
    final static String DEFAULT_DECAL = "decal.gif";
}

