/*
 * @(#)BrowserProperties.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */

package com.trapezium.browser;

import java.io.*;
import java.awt.*;
import java.util.*;

public class BrowserProperties {

	private static Properties properties = null;
	private static String filename = null;

	static {
		properties = new Properties();
		setDefaults(properties);
		filename = "browser.props";
	}

	public static void setDefaults(Properties properties) {
		properties.put("font.name", "Monospaced");
		properties.put("font.style", String.valueOf(Font.PLAIN));
		properties.put("font.size", "12");
		properties.put("tab.size", "4");
		properties.put("save.dir", ".");
	}

	public static Properties getProperties() {
		return properties;
	}

	public static void setProperties(String name) {
		try {
			FileInputStream in = new FileInputStream(name);
			properties.load(in);
			in.close();
			filename = name;

			System.out.println("Browser settings loaded from " + name);

		} catch (Exception e) {
//			System.out.println("Unable to load Browser settings from " + name);
		}
	}
	public static void saveProperties() {
		saveProperties(filename);
	}


	public static void saveProperties(String name) {
		try	{
			FileOutputStream out = new FileOutputStream(name);
			properties.save( out, "Browser settings" );
			out.close();
			filename = name;

		} catch (Exception e) {
			System.out.println("Unable to save Browser settings to " + name);
		}
	}
}
