/*
 * @(#)BrowserUniverse.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */
package com.trapezium.browser;

import java.awt.GraphicsConfiguration;
import javax.media.j3d.*;


/** the global reference frame for 3D information in the browser */
public class BrowserUniverse extends VirtualUniverse {

    // current locale (owner of viewing platform)
    LocaleTree locales;
    
	public BrowserUniverse() {
        super();
        locales = new LocaleTree(this);
	}

    public void setLocale(Locale locale) {
        locales.setCurrentLocale(locale);
    }

    public Locale getLocale() {
        return locales.getCurrentLocale();
    }

    /** see com.sun.j3d.utils.universe.SimpleUniverse.getPreferredConfiguration */
    public static GraphicsConfiguration getPreferredConfiguration() {
        return com.sun.j3d.utils.universe.SimpleUniverse.getPreferredConfiguration();
    }

}

