/*
 * @(#)SceneData.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 */
package com.trapezium.browser;

import com.trapezium.factory.FactoryResponseListener;
import com.trapezium.factory.FactoryData;
import com.trapezium.vrml.Scene;


/** a SceneData object is a ViewableData object with a scene graph
    information. */
public class SceneData extends ViewableData implements FactoryResponseListener {

    boolean loaded = false;

    public SceneData() {
        this(null);
    }

    public SceneData(String source) {
        super(source);
    }

	public void setScene( Scene scene ) {
        System.out.println("SceneData.setScene " + scene.getUrl());
	    super.setScene(scene);
	}

	public void done( FactoryData result ) {
        System.out.println("SceneData.done " + (result == this ? "ok" : "ERROR! wrong result!"));
	    loaded = !result.getAborted();
	}

	public void update( FactoryData result ) {
        System.out.println("SceneData.update " + (result == this ? "ok" : "ERROR! wrong result!"));
	}

	public void setNumberOfLines( int n ) {
        System.out.println("SceneData.setNumberOfLines " + n);
	}

	public void setPolygonCount( int n ) {
        System.out.println("SceneData.setPolygonCount " + n);
	}

	public void setAction( String action ) {
        System.out.println("SceneData.setAction " + action);
	}

	public void setText( String text ) {
        System.out.println("SceneData.setText " + text);
	}

	public void setFactoryData( FactoryData fd ) {
	    if (fd != this) {
	        throw new IllegalArgumentException("SceneData can't use FactoryData other than itself");
	    }
	}

	public void setLinePercent( int percentThousands ) {
	    ;
	}
}



