/*
 * @(#)ViewableContainer.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */

package com.trapezium.browser;

import javax.swing.event.ChangeListener;
import javax.media.j3d.BranchGroup;

public interface ViewableContainer {
    BranchGroup setViewableContents(Viewable obj, LoaderListener loaderListener);
    Viewable getViewableContents();

    /** add something to the container without replacing what's there */
    void addViewableContents(Viewable obj, LoaderListener loaderListener);

    /** Reset the view controls to their initial position */
    void resetViewControls();

    /** for thingies that need to know when the content changes */
    void addChangeListener(ChangeListener listener);
}

