/*
 * @(#)Visual.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */

package com.trapezium.browser;

import java.awt.Color;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;
import javax.vecmath.Vector4f;

/**
 *  A Visual object is one with a visible representation
 */
public interface Visual {

    // methods
    
    Point3f getLocation();
    void getLocation( Point3f returnPt );
    
    void setLocation( Point3f pt );
    void setLocation( float x, float y, float z );
    
    Vector4f getOrientation();
    void getOrientation( Vector4f returnOrient );
    
    void setOrientation( Vector4f orient );
    void setOrientation( float yaw, float pitch, float roll );
    
    /** Set the main color of an object.  With solid objects, this will
     *  generally map to getColor( "diffuseColor" ).  IndexedLineSets or
     *  PointSets would generally map to getColor( "emissiveColor" ), and
     *  lights to getColor( "color" ).
     */
    Color getColor();
    /** set a particular color field of an object */
    Color getColor( String fieldName );    

    /** get the main color of an object */
    void setColor(Color color);
    /** get the value of a particular color field */
    void setColor( String fieldName, Color color);

    Vector3f getScale();
    void getScale( Vector3f returnScale );
    
    void setScale( Vector3f scale );
    void setScale( float xScale, float yScale, float zScale );
    
    float getTransparency();
    void setTransparency( float trans );
}


