/*
 * @(#)Cone.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 *
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.Cone.java, which came with the
 * following notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

package com.trapezium.browser.vrml.node;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.BoundingBox;
import javax.media.j3d.Shape3D;
import javax.vecmath.Point3d;

public class Cone extends Geometry {

    /// field
    //SFFloat bottomRadius;
    //SFFloat height;
    //SFBool side;
    //SFBool bottom;

    public float bottomRadius;
    public float height;
    public boolean bottom;
    public boolean side;

    com.sun.j3d.utils.geometry.Primitive primitive;

    BoundingBox bounds;

	/** constructor */
	public Cone() {
		super();

	}
	public String getNodeName() {
	    return( "Cone" );
	}

	public boolean isPrimitive() {
	    return true;
	}

	public SceneGraphObject getSceneGraphObject() {
	    return primitive;
	}

    // this class fixes the problem in the j3d cone that arises when you 
    // remove cone parts
    class ChoppableCone extends com.sun.j3d.utils.geometry.Cone {
        public ChoppableCone (float radius, float height, int primflags, int xdivision, int ydivision, javax.media.j3d.Appearance ap) {
            super(radius, height, primflags, xdivision, ydivision, ap);
        }
        public void setAppearance(javax.media.j3d.Appearance ap) {

            javax.media.j3d.Node n = ((javax.media.j3d.Group)getChild(0)).getChild(BODY);
            if (n instanceof Shape3D) {
                // has a body
                ((Shape3D)n).setAppearance(ap);
                n.setCapability( javax.media.j3d.Node.ALLOW_LOCAL_TO_VWORLD_READ );
            }
            javax.media.j3d.Group g = (javax.media.j3d.Group)((javax.media.j3d.Group)getChild(0)).getChild(CAP);
            if (g.numChildren() > 0) {
                // has a cap
                ((Shape3D)g.getChild(0)).setAppearance(ap);
                g.getChild(0).setCapability( javax.media.j3d.Node.ALLOW_LOCAL_TO_VWORLD_READ );
            }
        }
    }

    public void realize() {
        
        super.realize();

	    primitive = new com.sun.j3d.utils.geometry.Cone( bottomRadius, height, com.sun.j3d.utils.geometry.Primitive.GENERATE_NORMALS | com.sun.j3d.utils.geometry.Primitive.GEOMETRY_NOT_SHARED | com.sun.j3d.utils.geometry.Primitive.GENERATE_TEXTURE_COORDS, 30, 4, null );

        //primitive.clearCapability(javax.media.j3d.Node.ENABLE_PICK_REPORTING);

    	//javax.media.j3d.Group g = (javax.media.j3d.Group) primitive.getChild(0);
        //g.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_READ);
        //g.clearCapability(javax.media.j3d.Node.ENABLE_PICK_REPORTING);
    //	javax.media.j3d.Group capGroup = (javax.media.j3d.Group) g.getChild(com.sun.j3d.utils.geometry.Cone.CAP);
        //capGroup.clearCapability(javax.media.j3d.Node.ENABLE_PICK_REPORTING);
        //capGroup.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_READ);
        
    //	if (!bottom) {
    //	    capGroup.removeChild(0);
    //	}
    //	if (!side) {
    	    // replace side with empty group (as a placeholder)
        //	javax.media.j3d.Group sideGroup = new javax.media.j3d.Group();
       //     sideGroup.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_READ);
       //     sideGroup.clearCapability(javax.media.j3d.Node.ENABLE_PICK_REPORTING);
    //	    g.setChild(sideGroup, com.sun.j3d.utils.geometry.Cone.BODY);
    //	}


    	bounds = new BoundingBox(new Point3d(-bottomRadius, -height/2.0, -bottomRadius),
                     			  new Point3d(bottomRadius, height/2.0, bottomRadius));
    }

    public void updateField(String fieldName, double time) {
        super.updateField(fieldName, time);
    }


    public BoundingBox getBoundingBox() {
        return bounds;
    }
}
