/*
 * @(#)Cylinder.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 *
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.Cylinder.java, which came with the following
 * notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */


package com.trapezium.browser.vrml.node;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.BoundingBox;
import javax.media.j3d.Shape3D;
import javax.vecmath.Point3d;

public class Cylinder extends Geometry {

    //// field
    //SFFloat radius;
    //SFFloat height;
    //SFBool side;
    //SFBool bottom;
    //SFBool top;

    public float radius;
    public float height;
    public boolean side;
    public boolean bottom;
    public boolean top;

    com.sun.j3d.utils.geometry.Primitive primitive;

    BoundingBox bounds;

	/** constructor */
	public Cylinder() {
		super();
	}
	public String getNodeName() {
	    return( "Cylinder" );
	}

	public boolean isPrimitive() {
	    return true;
	}

	public SceneGraphObject getSceneGraphObject() {
	    return primitive;
	}

    // this class fixes the problem in the j3d cylinder that arises when you 
    // remove cylinder parts
    class ChoppableCylinder extends com.sun.j3d.utils.geometry.Cylinder {
        public ChoppableCylinder (float radius, float height, int primflags, int xdivision, int ydivision, javax.media.j3d.Appearance ap) {
            super(radius, height, primflags, xdivision, ydivision, ap);
        }
        public void setAppearance(javax.media.j3d.Appearance ap) {

            javax.media.j3d.Group g = (javax.media.j3d.Group) getChild(0);
            javax.media.j3d.Node n = g.getChild(BODY);
            javax.media.j3d.Group gtop = (javax.media.j3d.Group) g.getChild(TOP);
            javax.media.j3d.Group gbottom = (javax.media.j3d.Group) g.getChild(BOTTOM);

            if (n instanceof Shape3D) {
                // has a body
                ((Shape3D)n).setAppearance(ap);
            }
            if (gtop.numChildren() > 0) {
                // has a top
                ((Shape3D)gtop.getChild(0)).setAppearance(ap);
            }
            if (gbottom.numChildren() > 0) {
                // has a bottom
                ((Shape3D)gbottom.getChild(0)).setAppearance(ap);
            }
        }
    }

    public void updateField(String fieldName, double time) {
        super.updateField(fieldName, time);
    }


    public void realize() {
        super.realize();

        primitive = new com.sun.j3d.utils.geometry.Cylinder(radius, height, com.sun.j3d.utils.geometry.Cylinder.GENERATE_NORMALS | com.sun.j3d.utils.geometry.Cylinder.GENERATE_TEXTURE_COORDS, 20, 2, null);
        primitive.clearCapability(javax.media.j3d.Node.ENABLE_PICK_REPORTING);

    	//javax.media.j3d.Group g = (javax.media.j3d.Group) primitive.getChild(0);
        javax.media.j3d.Shape3D gtop = primitive.getShape(com.sun.j3d.utils.geometry.Cylinder.TOP);
        javax.media.j3d.Shape3D gbottom = primitive.getShape(com.sun.j3d.utils.geometry.Cylinder.BOTTOM);
    	
        gtop.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_READ);
        gbottom.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_READ);
   	
    	// The util constructs a group with the side, a group containing only 
    	// the bottom and a group containing only the top as children.
    	

    	Point3d p1 = new Point3d( -radius, -height/2.0, -radius );
        Point3d p2 = new Point3d( radius, height/2.0, radius );
    	bounds = new BoundingBox( p1, p2 );
    }

    public BoundingBox getBoundingBox() {
        return bounds;
    }
}
