/*
 * @(#)DirectionalLight.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 *
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.DirectionalLight.java, which came with the
 * following notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

package com.trapezium.browser.vrml.node;

import javax.media.j3d.SharedGroup;
import javax.media.j3d.AmbientLight;
import javax.media.j3d.BoundingSphere;
import javax.vecmath.Vector3f;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;

public class DirectionalLight extends Light {

    //// exposedField
    //SFFloat ambientIntensity;
    //SFColor color;
    //SFVec3f direction;
    //SFFloat intensity;
    //SFBool on;


    public float[] direction;

    Vector3f lightDir;
    javax.media.j3d.DirectionalLight dirLight;

	/** constructor */
	public DirectionalLight() {
		super();
	}
	public String getNodeName() {
	    return( "DirectionalLight" );
	}

    public void realize() {
        super.realize();
    	lightDir = new Vector3f(direction[0], direction[1], direction[2]);
    	light = dirLight = new javax.media.j3d.DirectionalLight(on,	new Color3f(color[0] * intensity, color[1] * intensity, color[2] * intensity), lightDir);
    	dirLight.setInfluencingBounds(infiniteBounds);
    	group.addChild(dirLight);
    }

    void setScope(javax.media.j3d.Group scopeGroup) {
    	ambLight.addScope(scopeGroup);
    	dirLight.addScope(scopeGroup);
    }

    public void updateField(String fieldName, double time) {
    	if (fieldName.equals("direction")) {
    	    lightDir.x = direction[0];
    	    lightDir.y = direction[1];
    	    lightDir.z = direction[2];
    	    dirLight.setDirection(lightDir);
    	} else if (fieldName.equals("route_direction")) {
    	    dirLight.setCapability(javax.media.j3d.DirectionalLight.ALLOW_DIRECTION_WRITE);
    	} else {
    	    super.updateField(fieldName, time);
    	}
    }

}
