/*
 * @(#)Fog.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 * 
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.Fog.java, which came with the following
 * notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

package com.trapezium.browser.vrml.node;

import com.trapezium.browser.VrmlPlayer;
import javax.media.j3d.LinearFog;
import javax.media.j3d.ExponentialFog;
import java.util.Stack;

public class Fog extends BindableNode {

    // In BindableNode
    // eventIn
    //SFBool set_bind;
    // eventOut
    //SFBool isBound;

    //// exposedField
    //SFColor color;
    //SFString fogType;
    //SFFloat visibilityRange;


    javax.media.j3d.Fog fog;

	/** constructor */
	public Fog() {
		super();
	}

	public String getNodeName() {
	    return( "Fog" );
	}

	public Stack getStack() {
	    VrmlPlayer player = getPlayer();
	    if (player != null) {
	        return player.getFogStack();
	    }
	    return null;
	}

    public javax.media.j3d.SceneGraphObject getSceneGraphObject() {
        return fog;
    }
    
    public void realize() {

    	float[] color = getFloatArray("color");
    	String fogType = getStringValue("fogType");
    	float visibilityRange = getFloatValue("visibilityRange");
    	
    	//TODO: add event handlers for fogType eventIns.
    	//TOTO: move setCapabilities() event handler to be set only if ROUTE
    	if (fogType.equals("LINEAR")) {
    	    LinearFog linearFog = new LinearFog(color[0], color[1], color[2]);
    	    linearFog.setCapability(LinearFog.ALLOW_DISTANCE_WRITE);
    	    linearFog.setBackDistance(visibilityRange);
    	    linearFog.setFrontDistance(visibilityRange / 10.0);
    	    fog = linearFog;
    	} else {
    	    ExponentialFog expFog = new ExponentialFog(color[0], color[1], color[2]);
    	    expFog.setCapability(ExponentialFog.ALLOW_DENSITY_WRITE);
    	    expFog.setDensity(visibilityRange);
    	    fog = expFog;
    	}

    	// TODO: do only if ROUTE
    	fog.setCapability(javax.media.j3d.Fog.ALLOW_COLOR_READ);
    	fog.setCapability(javax.media.j3d.Fog.ALLOW_COLOR_WRITE);

    	if (visibilityRange == 0.0) {
    	    fog.setInfluencingBounds(zeroBounds);
    	} else {
    	    fog.setInfluencingBounds(infiniteBounds);
    	}
    }
}
