/*
 * @(#)ImageTexture.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 * 
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.ImageTexture.java, which came with the
 * following notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

package com.trapezium.browser.vrml.node;

import com.trapezium.browser.DataFile;
import com.trapezium.vrml.Scene;

import javax.media.j3d.Texture2D;
import javax.media.j3d.ImageComponent;
import javax.media.j3d.ImageComponent2D;
import java.awt.image.*;
import java.awt.geom.AffineTransform;
import java.awt.*;

public class ImageTexture extends Texture {

    //// exposedField
    //MFString url;
    //SFBool   repeatS;
    //SFBool   repeatT;

    public String[] url;
    

    /** constructor */
    public ImageTexture() {
        super();
    }
    public String getNodeName() {
        return( "ImageTexture" );
    }

    public void realize() {
        super.realize();
        startRetrieve();
    }

    public void updateField(String fieldName, double time) {
        if ( fieldName.equals("url") ) {
            startRetrieve();
        } else if (fieldName.equals("repeatS")) {
            if (texture != null) {
                if (getUpdatedBooleanValue("repeatS")) {
                    texture.setBoundaryModeS(javax.media.j3d.Texture.WRAP);
                } else {
                    texture.setBoundaryModeS(javax.media.j3d.Texture.CLAMP);
                }
            }
        } else if (fieldName.equals("repeatT")) {
            if (texture != null) {
                if (getUpdatedBooleanValue("repeatT")) {
                    texture.setBoundaryModeT(javax.media.j3d.Texture.WRAP);
                } else {
                    texture.setBoundaryModeT(javax.media.j3d.Texture.CLAMP);
                }
            }
        }
    }

    /** Start the retrieval thread, and set a flag indicating node is not fully
     *  realized until the "waitingForThread" flag is false.
     */
    void startRetrieve() {
        waitingForThread= true;
        updateWaiter();
        (new RetrieveTextureThread()).start();
    }

    class RetrieveTextureThread extends Thread {
        public void run() {
            byte[] bytes = null;
            if (url != null && url.length > 0) {
                Object source = ((Scene) getScene()).getSource();
                if (source != null && source instanceof DataFile) {
                    DataFile df = (DataFile) source;
                    for (int i = 0; i < url.length; i++) {
                        bytes = df.retrieveData(url[i]);
                        if (bytes != null && bytes.length > 0) {
                            createTexture(bytes);
                            break;
                        }
                    }
                }
            }
            waitingForThread = false;
        }
    }
}
