/*
 * @(#)Inline.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 * 
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.Inline.java, which came with the
 * following notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 *
 * @Author: Rick Goldberg
 * @Author: Doug Gehringer
 */

package com.trapezium.browser.vrml.node;

import com.trapezium.browser.DataFile;
import com.trapezium.util.StringUtil;
import com.trapezium.vrml.Scene;
import com.trapezium.vrml.VrmlElement;
import java.net.URL;
import java.util.Vector;
import java.util.Enumeration;
import javax.media.j3d.SceneGraphObject;

public class Inline extends GroupingNode {

    //// exposedfield
    //MFString url;

    //// field
    //SFVec3f bboxCenter;
    //SFVec3f bboxSize;

    public String[] url;
    public float[] bboxCenter;
    public float[] bboxSize;

    Scene scene;

	/** constructor */
	public Inline() {
		super();
	}
	public String getNodeName() {
	    return( "Inline" );
	}

    public void realize() {
        super.realize();
    	loadURL();
    }

    void loadURL() {
        (new RetrieveInlineThread()).start();
    }

  	class RetrieveInlineThread extends Thread {
  	    public void run() {
      	    byte[] bytes = null;
        	if (url != null && url.length > 0) {
        	    Object source = ((Scene) getScene()).getSource();
        	    if (source != null && source instanceof DataFile) {
            	    DataFile df = (DataFile) source;
            	    String baseFilePath = df.getBaseFilePath();

            	    for (int i = 0; i < url.length; i++) {
                        String u = url[i];
            	        if (( baseFilePath != null ) && ( u.indexOf( ":" ) < 0)) {
            	            u = StringUtil.stripQuotes( u );
            	            if ( u.charAt( 0 ) != '/' ) {
            	                u = baseFilePath + "/" + u;
            	            } else {
                	            u = baseFilePath + u;
                	        }
            	        } else {
                	        u = StringUtil.stripQuotes( u );
                	    }
                	    if ( u != null ) {
                	        scene = new Scene( u );
                	        realizeScene(scene);
                	        
                	        /// I don' think we need this
                	        /// 
                	        /// if ( s.getTokenEnumerator() != null ) {
                    	    ///     PROTOcollector protoCollector = new PROTOcollector( s, (Scene)n.getScene() );
                    	    ///     s.traverse( protoCollector );
                    	    ///     if ( protoCollector.hasPROTOs() ) {
                    	    ///         replaceRange( 1, 1, protoCollector );
                    	    ///     }
                    	    ///     if ( s.getTokenEnumerator() != null ) {
            		        ///         replaceRange( n.getFirstTokenOffset(), 
                    		/// 		    n.getLastTokenOffset(), new SceneProtoCollector( protoCollector ));
                    		/// 	}
                    		/// 	if ( protoCollector.hasROUTEs() ) {
                    		/// 	    pcList.addElement( protoCollector );
                    		/// 	}
                			/// }
            			}
        			}
               	}
        	}
      	}
    }

    
    void realizeScene(Scene scene) {	
        removeAllChildren();
	    int nChildren = scene.numberChildren();
		for ( int i = 0; i < nChildren; i++ ) {
			VrmlElement e = scene.getChildAt( i );
			if ( e instanceof RealizableNode ) {
			    RealizableNode node = (RealizableNode) e;
			    node.realize();
			    SceneGraphObject obj = node.getSceneGraphObject();
			    if (obj != null && obj instanceof javax.media.j3d.Node) {
    			    j3dGroup.addChild((javax.media.j3d.Node) obj);
    			}
			}
	    }
    }
    	

    public void updateField(String fieldName, double time) {
    	if (fieldName.equals("url")) {
    	    loadURL();
    	}
    }

}
