/*
 * @(#)PointLight.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 * 
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.PointLight.java, which came with the
 * following notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */


package com.trapezium.browser.vrml.node;

import javax.media.j3d.SharedGroup;
import javax.media.j3d.AmbientLight;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Link;
import javax.vecmath.Point3f;
import javax.vecmath.Color3f;

public class PointLight extends Light {

    //SFFloat ambientIntensity;
    //SFVec3f attenuation;
    //SFColor color;
    //SFFloat intensity;
    //SFVec3f location;
    //SFBool  on;
    //SFFloat radius;

    public float[] attenuation;
    public float[] location;
    public float radius;

    Point3f lightPos;
    Point3f lightAtt;
    BoundingSphere bounds;
    javax.media.j3d.PointLight pointLight;

	/** constructor */
	public PointLight() {
		super();
	}
	public String getNodeName() {
	    return( "PointLight" );
	}


    public void realize() {
        super.realize();
    	bounds = new BoundingSphere();
	    bounds.setRadius((double) radius);
        lightPos = new Point3f(location[0], location[1], location[2]);
        lightAtt = new Point3f(attenuation[0], attenuation[1], attenuation[2]);
        light = pointLight = new javax.media.j3d.PointLight(on, new Color3f(color[0] * intensity, color[1] * intensity, color[2] * intensity), lightPos, lightAtt);
    	ambLight.setInfluencingBounds(bounds);
    	pointLight.setInfluencingBounds(bounds);
        group.addChild(pointLight);
    }


    public void updateField(String fieldName, double time) {
        if (fieldName.equals("location")) {
            lightPos.x = location[0];
            lightPos.y = location[1];
            lightPos.z = location[2];
            pointLight.setPosition(lightPos);
        } else if (fieldName.equals("attenuation")) {
            lightAtt.x = attenuation[0];
            lightAtt.y = attenuation[1];
            lightAtt.z = attenuation[2];
            pointLight.setAttenuation(lightAtt);
        } else if (fieldName.equals("radius")) {
    	    bounds.setRadius((double) radius);
	        ambLight.setInfluencingBounds(bounds);
	        pointLight.setInfluencingBounds(bounds);
        } else if (fieldName.equals("route_location")) {
            pointLight.setCapability(javax.media.j3d.PointLight.ALLOW_POSITION_WRITE);
        } else if (fieldName.equals("route_attenuation")) {
            pointLight.setCapability(javax.media.j3d.PointLight.ALLOW_ATTENUATION_WRITE);
        } else if (fieldName.equals("route_radius")) {
            ambLight.setCapability(javax.media.j3d.Light.ALLOW_INFLUENCING_BOUNDS_WRITE);
            pointLight.setCapability(javax.media.j3d.Light.ALLOW_INFLUENCING_BOUNDS_WRITE);
        } else {
            super.updateField(fieldName, time);
        }
    }
}
