/*
 * @(#)Switch.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 * 
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.Switch.java, which came with the
 * following notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */


package com.trapezium.browser.vrml.node;
import java.util.Vector;

public class Switch extends GroupingNode {
    //// exposedField
    //MFNode choice;

    //// field
    //SFInt32 whichChoice;

    public RealizableNode[] choice;
    public int whichChoice;
    
	/** constructor */
	public Switch() {
		super();
	}
	public String getNodeName() {
	    return( "Switch" );
	}

    public void realize() {
        javax.media.j3d.Switch sw = new javax.media.j3d.Switch();
        super.realize(sw, null);
        
    	sw.setCapability(javax.media.j3d.Switch.ALLOW_SWITCH_READ);
    	sw.setCapability(javax.media.j3d.Switch.ALLOW_SWITCH_WRITE);
    	sw.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_READ);
    	sw.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_WRITE);
    	sw.setCapability(javax.media.j3d.Group.ALLOW_CHILDREN_EXTEND);
    	updateChildren("choice");
    	setWhichChild();
    }

    public void setWhichChild() {
        javax.media.j3d.Switch sw = (javax.media.j3d.Switch) j3dGroup;       
    	if (whichChoice < 0 || whichChoice > sw.numChildren()) {
    	    sw.setWhichChild(javax.media.j3d.Switch.CHILD_NONE);
    	} else {
    	    sw.setWhichChild(whichChoice);
    	}
    }


    public void updateField(String fieldName, double time) {
    	if (fieldName.equals("choice")) {
    	    updateChildren(fieldName);
    	} else if (fieldName.equals("whichChoice")) {
    	    setWhichChild();
    	} else {
    	    super.updateField(fieldName, time);
    	}
    }

}
