/*
 * @(#)Text.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 *
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.Text.java, which came with the following
 * notice:
 *.............................................................................
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */

package com.trapezium.browser.vrml.node;

import com.trapezium.browser.geometry.Text2DArray;

import java.awt.Font;
import javax.vecmath.Color3f;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Text3D;
import com.sun.j3d.utils.geometry.*;

public class Text extends Geometry {

    //Text2DArray text = null;
    Text3D text = null;

	/** constructor */
	public Text() {
		super();
	}
	public String getNodeName() {
	    return( "Text" );
	}

    public boolean isText() {
        return true;
    }

    public void realize() {
        super.realize();
        String[] string = getStringArray("string");
        com.trapezium.vrml.node.Node fontStyle = getUpdatedNodeValue( "fontStyle" );
        String vrmlFamily = "SERIF";
        String style = "PLAIN";
        System.out.println( "fontStyle is " + fontStyle );
        if ( fontStyle != null ) {
            vrmlFamily = fontStyle.getStringValue( "family" );
            style = fontStyle.getStringValue( "style" );
            System.out.println( "now family is " + vrmlFamily + ", and style is " + style );
        }
        int textStyle = java.awt.Font.PLAIN;
        String family = "TimesRoman";
        if ( vrmlFamily.compareTo( "\"SERIF\"" ) == 0 ) {
            family = "TimesRoman";
        } else if ( vrmlFamily.compareTo( "\"SANS\"" ) == 0 ) {
            family = "Helvetica";
        } else if ( vrmlFamily.compareTo( "\"TYPEWRITER\"" ) == 0 ) {
            family = "Courier";
        }
        if ( style.compareTo( "PLAIN" ) == 0 ) {
            textStyle = java.awt.Font.PLAIN;
        } else if ( style.compareTo( "BOLD" ) == 0 ) {
            textStyle = java.awt.Font.BOLD;
        } else if ( style.compareTo( "ITALIC" ) == 0 ) {
            textStyle = java.awt.Font.ITALIC;
        } else if ( style.compareTo( "BOLDITALIC" ) == 0 ) {
            textStyle = java.awt.Font.ITALIC | java.awt.Font.BOLD;
        }
        if (string != null && string.length > 0) {
    	    //text = new Text2DArray(string, new Color3f(1.0f, 1.0f, 1.0f), "Serif", 60, Font.BOLD);
            //System.out.println( "text is " + text );
            //text = new Text3D();
            //text.setString( string[0] );
             javax.media.j3d.Font3D f3d = new javax.media.j3d.Font3D( new java.awt.Font( family, textStyle, 1 ), new javax.media.j3d.FontExtrusion() );
             text = new javax.media.j3d.Text3D( f3d, string[0], new javax.vecmath.Point3f( -1f, -1f, -1f ));
//text.setString( string[0] );
           System.out.println( "REALIZE TEXT NODE, string is " + string[0] );
       	}
    }

    public SceneGraphObject getSceneGraphObject() {
        System.out.println( "TEXT NODE " + this + " RETURNING " + text );
        return text;
    }

    public javax.media.j3d.BoundingBox getBoundingBox() {
        return null;
    }

    public void updateField(String fieldName, double time) {
        super.updateField(fieldName, time);
    }

}