/*
 * @(#)Texture.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */

package com.trapezium.browser.vrml.node;

import java.awt.Toolkit;
import java.awt.Image;
import java.awt.image.*;
import javax.media.j3d.ImageComponent;
import javax.media.j3d.ImageComponent2D;
import javax.media.j3d.SceneGraphObject;
import javax.media.j3d.Texture2D;

public abstract class Texture extends RealizableNode implements ImageObserver {

    javax.media.j3d.Texture texture;

    int width;
    int height;

    /** constructor */
    public Texture() {
        super();
    }

    public SceneGraphObject getSceneGraphObject() {
if ( texture == null ) System.out.println( "Texture::getSceneGraphObject returnnig null" );
else System.out.println( "Texture::getSceneGraphObject returning a valid texture" );
        return texture;
    }

    protected void realize(javax.media.j3d.Texture t) {
        super.realize();
        texture = t;
    }
    
    public void realize() {
System.out.println( "Realize Texture called" );
        super.realize();
System.out.println( "Texture::realize setting texture to null" );
        texture = null;
System.out.println( "Texture::realize done" );
    }
    
    protected void createTexture(byte[] bytes) {
System.out.println( "Texture::CreateTexture called!" );
        Image mimage = Toolkit.getDefaultToolkit().createImage(bytes);
        int w = mimage.getWidth(this);
        int h = mimage.getHeight(this);
        Image aux = mimage.getScaledInstance(512, 512, Image.SCALE_DEFAULT);
        PixelGrabber pg = new PixelGrabber(aux, 0, 0, 512, 512, true);
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
        }
        int[] dat = (int[])pg.getPixels();

        DirectColorModel colorModel = new DirectColorModel(32, 0xff000000, 0xff0000, 0xff00, 0xff);
        WritableRaster raster = colorModel.createCompatibleWritableRaster(512,512);

        int[] tdat = ((DataBufferInt)raster.getDataBuffer()).getData();

        for (int i = 0; i < 512*512; i++) {
            int p = dat[i];
            int a = (p >> 24) & 0xff;
            int r = (p >> 16) & 0xff;
            int g = (p >> 8) & 0xff;
            int b = (p) & 0xff;
            tdat[i] = (r << 24) | (g << 16) | (b << 8) | (a);
        }
        BufferedImage buf = new BufferedImage(colorModel, raster, false, null);

        ImageComponent imageComponent =  new ImageComponent2D(ImageComponent.FORMAT_RGBA, buf);
        texture = new Texture2D(javax.media.j3d.Texture.BASE_LEVEL, javax.media.j3d.Texture.RGB, imageComponent.getWidth(), imageComponent.getHeight());
        texture.setMinFilter(javax.media.j3d.Texture.BASE_LEVEL_LINEAR);
        texture.setMagFilter(javax.media.j3d.Texture.BASE_LEVEL_LINEAR);
        texture.setImage(0, imageComponent);
        texture.setEnable(true);
        com.trapezium.vrml.node.Node n = getParent( "Appearance" );
        if ( n instanceof RealizableNode ) {	
            ((RealizableNode)n).updateField( "texture", 0 );
        }
    }

    public boolean imageUpdate(Image img, int info, int x, int y, int w, int h ) {
        boolean moreUpdates = true;
        Thread t = Thread.currentThread();
        t.setPriority(5);
        if ((( info & ImageObserver.WIDTH) != 0) && (( info & ImageObserver.HEIGHT) != 0)) {
            moreUpdates = false;
            this.width = w;
            this.height = h;
        }

        return moreUpdates;
    }
}
