/*
 * @(#)TextureTransform.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All rights reserved.
 *
 * The original code in this file is the property of Trapezium Development
 * LLC and may be used only in accordance with the terms of the license
 * granted by Trapezium.
 * 
 * Some of the code in this file was adapted by Trapezium from
 * com.sun.j3d.loaders.vrml97.impl.TextureTransform.java, which came with the
 * following notice:
 *.............................................................................
 *
 * Copyright (c) 1996-1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Sun grants you ("Licensee") a non-exclusive, royalty free, license to use,
 * modify and redistribute this software in source and binary code form,
 * provided that i) this copyright notice and license appear on all copies of
 * the software; and ii) Licensee does not utilize the software in a manner
 * which is disparaging to Sun.
 *
 * This software is provided "AS IS," without a warranty of any kind. ALL
 * EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
 * IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN AND ITS LICENSORS SHALL NOT BE
 * LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING
 * OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS
 * LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT,
 * INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
 * CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF
 * OR INABILITY TO USE SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * This software is not designed or intended for use in on-line control of
 * aircraft, air traffic, aircraft navigation or aircraft communications; or in
 * the design, construction, operation or maintenance of any nuclear
 * facility. Licensee represents and warrants that it will not use or
 * redistribute the Software for such purposes.
 */


package com.trapezium.browser.vrml.node;

import javax.media.j3d.TextureAttributes;
import javax.media.j3d.Transform3D;
import javax.vecmath.*;

public class TextureTransform extends Appearances {

    //// exposedField
    //SFVec2f center;
    //SFFloat rotation;
    //SFVec2f scale;
    //SFVec2f translation;

    public float[] center;
    public float rotation;
    public float[] scale;
    public float[] translation;

    TextureAttributes ta = new javax.media.j3d.TextureAttributes();

	/** constructor */
	public TextureTransform() {
		super();
	}
	public String getNodeName() {
	    return( "TextureTransform" );
	}
	
    public javax.media.j3d.SceneGraphObject getSceneGraphObject() {
        return ta;
    }

    public void realize() {
        super.realize();
        updateTransform();
    }
    
    public void updateField(String fieldName, double time) {
        updateTransform();
    }

    void updateTransform() {
        Transform3D tr = new Transform3D();
        Transform3D T = new Transform3D();
        Transform3D C = new Transform3D();
        Transform3D R = new Transform3D();
        Transform3D S = new Transform3D();
        Vector3f v1 = new Vector3f();
        Vector3f v2 = new Vector3f();
        Vector3d v3 = new Vector3d();
        Vector3f v4 = new Vector3f();
        AxisAngle4f al = new AxisAngle4f();
	    
	    v1.set(translation[0], translation[1], 0.0f);
	    T.set(v1);

	    v2.set(center[0], center[1], 0.0f);
	    C.set(v2);

	    al.set(0.0f, 0.0f, 1.0f, rotation);
	    R.setRotation(al);

	    v3.set((double) scale[0], (double) scale[1], 1.0);
	    S.setScale(v3);

	    tr.setIdentity();
	    tr.mul(T);
	    tr.mul(C);
	    tr.mul(R);
	    tr.mul(S);
	    v2.negate();
	    C.set(v2);
	    tr.mul(C);

	    ta.setTextureTransform(tr);
    }
}
