/*
 * @(#)DataFile.java
 *
 * Copyright (c) 1998-1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 */

package com.trapezium.factory;

/**
 *  The FactoryResponseListener interface is used by the parser to provide
 *  ongoing information to the application about the state of parsing a 
 *  VRML text file.
 */

public interface FactoryResponseListener {
    /** Called when parsing is complete */
    void done( FactoryData result );

    void update( FactoryData result );
    void setNumberOfLines( int n );
    void setPolygonCount( int n );
    void setAction( String action );
    void setText( String text );
    void setFactoryData( FactoryData fd );
    void setLinePercent( int percentThousands );
}
