
package com.trapezium.test;
import java.applet.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.awt.BorderLayout;
import java.awt.event.*;
import java.awt.Image;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/**-------------------------------------------------------------------
   Credits:
   Sign program by Kirk Brown

--------------------------------------------------------------------*/

public class Sign extends Applet {


     // Pre-defined colors
     Color3f white = new Color3f(1.0f, 1.0f, 1.0f);
     Color3f black = new Color3f(0.0f, 0.0f, 0.0f);
   Color3f gray = new Color3f(0.6f, 0.6f, 0.6f);
    // Local Variable Declarations
    //
    String sign = new String("sign1.jpg");
    String back = new String("back.gif");
    Image signimg;
    Image backimg;
    Color3f backcolor = black;

    // Need these flags because the background can be:
    //      a local image source when run standalone
    //      a full URL image source when run as applet
    //      or just a solid color
    //
    boolean applet = false;
    URL imageURL;
    URL backURL;


    private BranchGroup createSceneGraph() {

       // Create the root of the branch graph
       //
       BranchGroup objRoot = new BranchGroup();

       // This Transform Group Scales the objects so they fit the scene
       //
       TransformGroup objScale = new TransformGroup();
         Transform3D t3d = new Transform3D();
         t3d.setScale(0.4);
         objScale.setTransform(t3d);
         objRoot.addChild(objScale);

      // Create a bounds for the background, behaviors and lights
      //
      BoundingSphere bounds =
         new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

       // Set up the background. Texture with an image or a solid.
       // Default is solid.
       //
       Background bg = new Background(backcolor);

       // Try to get the image URL for the background else
       // we'll just use a solid.
       //
       bg.setApplicationBounds(bounds);
       objRoot.addChild(bg);

     // Set up lights
     //
     Color3f lColor1 = new Color3f(0.7f, 0.7f, 0.7f);
     Vector3f lDir1  = new Vector3f(-1.0f, -1.0f, -1.0f);
     Color3f alColor = new Color3f(0.8f, 0.8f, 0.8f);

     AmbientLight aLgt = new AmbientLight(alColor);
     aLgt.setInfluencingBounds(bounds);
     objScale.addChild(aLgt);

     DirectionalLight lgt1 = new DirectionalLight(lColor1, lDir1);
     lgt1.setInfluencingBounds(bounds);
     objScale.addChild(lgt1);

    // Create Appearance properties. Texture the Sign with an
      // image or else use a default.
	    //
	    Appearance app = new Appearance();

      // Assume a solid surface by default.
      app.setMaterial(new Material(gray, black, gray, white, 1.0f));

      if (sign != null) {
		          TextureLoader tex = new TextureLoader(sign,
                                       new String("RGB"),
                                       0,
                                       this);
              if (tex != null)
		                  app.setTexture(tex.getTexture());
	    }

	    // Create the Sign which is a rectangle
	    //
	    Primitive thesign =  new Box(1.0f, 0.6f, 0.1f,
			                   Box.GENERATE_TEXTURE_COORDS |
			                   Box.GENERATE_NORMALS, app);

      // Rotate the Sign slowly.
      TransformGroup signRot = new Rotator(new Transform3D());

	    // Add everything to the Scene Graph
	    //
	    objScale.addChild(signRot);
	    signRot.addChild(thesign);

	    return objRoot;
    }

    public void init() {

        setLayout(new BorderLayout());
        Canvas3D c = new Canvas3D(null);
        add("Center", c);

	      // Create a simple scene and attach it to the virtual universe
	      BranchGroup scene = createSceneGraph();
	      SimpleUniverse u = new SimpleUniverse(c);

        // This will move the ViewPlatform back a bit so the
        // objects in the scene can be viewed.
        u.getViewingPlatform().setNominalViewingTransform();

	      u.addBranchGraph(scene);
    }


    //
    // The following allows Sign to be run as an application
    // as well as an applet
    //
    public static void main(String[] args) {
       if (args.length > 0) {
           // Parse Input Arguments
           for (int i = 0; i < args.length; i++) {

               if (args[i].equals("-demo")) {
                   new MainFrame(new Sign(), 400, 200);
               } else {
		               System.out.println("Usage: java Sign -demo");
                   System.exit(0);
	             }
           }
       } else {
           System.out.println("Usage: java Sign -demo");
           System.exit(0);
       }
    } // END Main

}
