package com.trapezium.text;

import java.io.*;
public class InfoDesign {
    static public void main( String[] args ) {
        System.out.println( "InfoDesign, v0.1, copyright 1999, Trapezium Development LLC" );
        if ( args.length == 1 ) {
            //System.out.println( "opening '" + args[0] + "'" );
            InfoDataStore ids = new InfoDataStore();
            try {
                LineNumberReader lineReader = new LineNumberReader( new InputStreamReader( new FileInputStream( args[0] )));
                String s = lineReader.readLine();
                while ( true ) {
                    if ( s == null ) {
                        break;
                    }
                    //System.out.println( "Processing directory '" + s + "'" );
                    InfoDirectoryProcessor idp = new InfoDirectoryProcessor( s, ids );
                    ids.addInfoDirectory( idp );
                    while ( true ) {
                        s = lineReader.readLine();
                        if ( s == null ) {
                            break;
                        }
                        if ( s.charAt( 0 ) == '#' ) {
                            idp.modify( s.substring(1) );
                        } else {
                            break;
                        }
                    }
                    idp.process();
                }
                InfoVrmlGenerator ivg = new InfoVrmlGenerator( ids );
                System.out.println( "Generating VRML" );
                ivg.generate();
                System.out.println( "VRML in: info.wrl" );
                ids.summary();
                ObjectOutputStream oos = new ObjectOutputStream( new FileOutputStream( "ids.obj" ));
                oos.writeObject( ids );
                oos.flush();
                oos.close();
            } catch ( Exception e ) {
                System.out.println( "exception: " + e );
                e.printStackTrace();
            }
        }
    }
}