package com.trapezium.text;

import java.io.*;
import java.util.Vector;

public class InfoDirectoryProcessor {
    String directoryName;
    InfoDataStore infoDataStore;
    Vector modificationList;
    String label;
    
    public InfoDirectoryProcessor( String directoryName, InfoDataStore infoDataStore ) {
        this.directoryName = directoryName;
        this.infoDataStore = infoDataStore;
        modificationList = new Vector();
        infoDataStore.setSection( directoryName, modificationList );
        label = null;
    }
    
    public void modify( String s ) {
        if ( s.indexOf( "#" ) == 0 ) {
            setLabel( s.substring( 1 ));
        } else {
            modificationList.addElement( s );
        }
    }
    
    public void setLabel( String label ) {
        this.label = label;
    }
    
    public String getLabel() {
        return( label );
    }
    
    public void process() {
        File dirFile = new File( directoryName );
        if ( dirFile.isDirectory() ) {
            String[] dirFiles = dirFile.list();
            //System.out.println( ".." + dirFiles.length + " files:" );
            for ( int i = 0; i < dirFiles.length; i++ ) {
                //System.out.println( "..processing " + dirFiles[i] );
                processFile( directoryName + "/" + dirFiles[i] );
            }
        } else {
            System.out.println( "Not a directory" );
        }
    }
    
    void processFile( String fileName ) {
        infoDataStore.incPageGroupPageCount();
        try {
            LineNumberReader lineReader = new LineNumberReader( new InputStreamReader( new FileInputStream( fileName )));
            while ( true ) {
                String s = lineReader.readLine();
                if ( s == null ) {
                    break;
                }
                infoDataStore.processLine( fileName, s );
            }
        } catch ( Exception e ) {
            System.out.println( "exception: " + e );
        }
    }
}