package com.trapezium.text;

import java.util.Vector;

class PageGroup implements java.io.Serializable {
    String section;
    int count;
    Vector pages;
        
    public PageGroup( String section ) {
        this.section = section;
        count = 0;
        pages = new Vector();
    }
        
    public void addPage( PageRepresentation pr ) {
        pages.addElement( pr );
    }
        
    public int getPageOffset( PageRepresentation pr ) {
        int numberPages = pages.size();
        for ( int i = 0; i < numberPages; i++ ) {
            if ( pr == pages.elementAt( i )) {
                return( i );
            }
        }
        return( -1 );
    }
        
    public String getSectionName() {
        return( section );
    }
        
    public void incPageCount() {
        count++;
    }
        
    public int getPageCount() {
        return( count );
    }
    
    public int getNumberPages() {
        return( pages.size() );
    }
}
