/*
 * @(#)BaseAction.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */

package com.trapezium.util;

import javax.swing.Action;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;

import java.awt.*;
import java.awt.event.*;
import java.util.*;


/** This static class connects command strings with ActionListeners,
    allowing user interface elements such as buttons initialize
    themselves without having to know who is listening to them.
*/

abstract public class BaseAction extends AbstractAction {
    protected static Hashtable commands = new Hashtable();

    public static BaseAction delegateAction(String name, ActionListener listener) {
        return new ActionDelegator(name, listener);
    }

    public BaseAction() {
        super();
    }
    
    public BaseAction(String name) {
        super(name);
        addCommand(name);
    }

    public void addCommand(String name) {
        commands.put(name, this);
    }
    
    public static Action getAction(String cmd) {
        Action a = (Action) commands.get(cmd);
        return a;
    }
}

class ActionDelegator extends BaseAction {
    ActionListener listener;
    
    public ActionDelegator(String name, ActionListener listener) {
        super(name);
        this.listener = listener;
    }
        
    public void actionPerformed(ActionEvent e) {
        listener.actionPerformed(e);
    }
}
        
        