/*
 * @(#)FocuslessButton.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */
package com.trapezium.util;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.ComponentUI;
import javax.accessibility.*;

/** buttons for toolbars and titlebars which don't get the focus */
public class FocuslessButton extends JButton {

    public FocuslessButton() {
        setFocusPainted(false);
    }
        
    public FocuslessButton(Icon icon) {
        super(icon);
        setFocusPainted(false);
    }

    public boolean isFocusTraversable() {
        return false;
    }

    public void requestFocus() {
        ;
    }

    public boolean isOpaque() {
        return true;
    }

}

