/*
 * @(#)GenerateYek.java
 *
 * Copyright (c) 1998 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */
package com.trapezium.util;

import java.io.File;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;

/** program to create and serialize a program key

    Instructions:

        java com.trapezium.util.GenerateYek appName userName userEmail daysTillExpiration

*/

public class GenerateYek {
    public static void main( String[] args ) {
        if (args.length < 3) {
            System.out.println("Program usage:\n\n    java com.trapezium.util.GenerateYek appname username useremail [#days]");
            System.out.println(" or java com.trapezium.util.GenerateYek appname Evaluation #days");
            System.exit(0);
        }
        System.out.println(args[0]);
        System.out.println(args[1]);
        System.out.println(args[2]);
        
        String name = args[1];
        String email;
        int days;
        if (name.equals("Evaluation")) {
            email = "";
            days = Integer.parseInt(args[2]);
        } else {
            email = args[2];
            days = (args.length < 4 ? -1 : Integer.parseInt(args[3]));
        }
        
        ProgramYek py = new ProgramYek( args[0], name, email, days );
        serialize( py, args[0] + ".key" );
        System.out.println("KEY: " + py.getAppPrefix() + "-" + py.toString());
    }

    static public void serialize( ProgramYek py, String fileName ) {
        File f = new File( fileName );
        try {
            FileOutputStream fos = new FileOutputStream( f );
            //ObjectOutputStream oos = new ObjectOutputStream( fos );
            //oos.writeObject( py );
            py.write(fos);
            fos.flush();
            fos.close();
        } catch ( Exception e ) {
            System.out.println( "** Exception " + e );
            e.printStackTrace();
        }
    }
}
