/*
 * @(#)Stage3ControllerPanel.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */
package com.trapezium.virtualworld;

import com.trapezium.browser.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.*;

/** the panel containing the controls for interacting with the contents
    of the viewer */
public class Stage3ControllerPanel extends JPanel {

    // top half of controller panel
    JTabbedPane tabbedPane;

    // the panes belonging to tabbedPane
    JPanel coverPanel;              String coverLabel = "Cover";
    JPanel mapPanel;                String mapLabel = "Story Map";
    JPanel timegraphPanel;          String timegraphLabel = "Timegraph";
    JPanel stagePanel;              String stageLabel = "Stages";
    JPanel castPanel;               String castLabel = "Actors";
    JPanel eventPanel;              String eventLabel = "Events";
    JPanel epilogPanel;             String epilogLabel = "Epilog";

    // bottom half of controller panel
    JPanel propertyPane;

    public Stage3ControllerPanel(ViewableContainer viewer) {
        super();
        setLayout(new BorderLayout());

        tabbedPane = new Stage3TabbedPane();        
        propertyPane = new PropertyPane();

    	coverPanel = new JPanel();
    	tabbedPane.addTab(coverLabel, coverPanel);

    	mapPanel = new JPanel();
    	tabbedPane.addTab(mapLabel, mapPanel);

    	timegraphPanel = new JPanel();
    	tabbedPane.addTab(timegraphLabel, timegraphPanel);

    	stagePanel = new JPanel();
    	tabbedPane.addTab(stageLabel, stagePanel);

    	castPanel = new JPanel();
    	tabbedPane.addTab(castLabel, castPanel);

    	eventPanel = new JPanel();
    	tabbedPane.addTab(eventLabel, eventPanel);

    	epilogPanel = new JPanel();
    	tabbedPane.addTab(epilogLabel, epilogPanel);

        JComponent divpane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, tabbedPane, propertyPane);
    	add(divpane, BorderLayout.CENTER);
    }

    public Dimension getPreferredSize() {
        return new Dimension(400, 400);
    }
    
    public void updateControllers() {
    }
    
    
    class Stage3TabbedPane extends JTabbedPane {
        
        public Stage3TabbedPane() {
            super();
            setTabPlacement(BOTTOM);
        }
        public Dimension getPreferredSize() {
            return new Dimension(400, 400);
        }
    }
    
}

class PropertyPane extends JPanel {

    //ComposableObject 
    
    public PropertyPane() {
        super();
    }
}    
/*****    
class DrawPanel extends Panel implements MouseListener, MouseMotionListener {
    public static final int LINES = 0;
    public static final int POINTS = 1;
    int	   mode = LINES;
    Vector lines = new Vector();
    Vector colors = new Vector();
    int x1,y1;
    int x2,y2;
    int xl, yl;

    public DrawPanel() {
	setBackground(Color.white);
	addMouseMotionListener(this);
	addMouseListener(this);
    }

    public void setDrawMode(int mode) {
	switch (mode) {
	  case LINES:
	  case POINTS:
	    this.mode = mode;
	    break;
	  default:
	    throw new IllegalArgumentException();
	}
    }


    public void mouseDragged(MouseEvent e) {
        e.consume();
        switch (mode) {
            case LINES:
                xl = x2;
                yl = y2;
                x2 = e.getX();
                y2 = e.getY();
                break;
            case POINTS:
            default:
                colors.addElement(getForeground());
                lines.addElement(new Rectangle(x1, y1, e.getX(), e.getY()));
                x1 = e.getX();
                y1 = e.getY();
                break;
        }
        repaint();
    }

    public void mouseMoved(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
        e.consume();
        switch (mode) {
            case LINES:
                x1 = e.getX();
                y1 = e.getY();
                x2 = -1;
                break;
            case POINTS:
            default:
                colors.addElement(getForeground());
                lines.addElement(new Rectangle(e.getX(), e.getY(), -1, -1));
                x1 = e.getX();
                y1 = e.getY();
                repaint();
                break;
        }
    }

    public void mouseReleased(MouseEvent e) {
        e.consume();
        switch (mode) {
            case LINES:
                colors.addElement(getForeground());
                lines.addElement(new Rectangle(x1, y1, e.getX(), e.getY()));
                x2 = xl = -1;
                break;
            case POINTS:
            default:
                break;
        }
        repaint();
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
    }

    public void paint(Graphics g) {
	int np = lines.size();

	// draw the current lines
	g.setColor(getForeground());
	g.setPaintMode();
	for (int i=0; i < np; i++) {
	    Rectangle p = (Rectangle)lines.elementAt(i);
	    g.setColor((Color)colors.elementAt(i));
	    if (p.width != -1) {
		g.drawLine(p.x, p.y, p.width, p.height);
	    } else {
		g.drawLine(p.x, p.y, p.x, p.y);
	    }
	}
	if (mode == LINES) {
	    g.setXORMode(getBackground());
	    if (xl != -1) {
		// erase the last line.
		g.drawLine(x1, y1, xl, yl);
	    }
	    g.setColor(getForeground());
	    g.setPaintMode();
	    if (x2 != -1) {
		g.drawLine(x1, y1, x2, y2);
	    }
	}
    }
}
***/
