package com.trapezium.vizwiz;

import java.io.OutputStream;

public class ConnectionIndicator implements Runnable {
    
    OutputStream sos;
    boolean running;
    
    public ConnectionIndicator() {
        sos = null;
        running = false;
    }
    
    public void reset() {
        sos = null;
    }
    
    public synchronized void setOutputStream( OutputStream sos ) {
        this.sos = sos;
        System.out.println( "ConnectionIndicator setting output stream!" );
        if ( !running ) {
            startup();
        }
    }
    
    public synchronized void writeData( byte[] data ) throws java.io.IOException {
        System.out.println( "ConnectionIndicator writing data.." );
        sos.write( data );
    }
    
    void startup() {
        System.out.println( "ConnectionIndicator starting up!" );
        new Thread(this).start();
    }
    
    public void run() {
        System.out.println( "ConnectionIndicator starting to run" );
        running = true;
        byte[] aliveIndicator = new byte[2];
        aliveIndicator[0] = (byte)'a';
        aliveIndicator[1] = (byte)0;
        try {
            while ( true ) {
                try {
                    Thread.sleep( 10000 );
                } catch ( Exception e ) {
                }
                writeData( aliveIndicator );
            }
        } catch ( Exception e ) {
            System.out.println( "ConnectionIndicator stopping run: " + e );
        }
        running = false;
    }
}
        