/*
 * @(#)Command.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */
 
package com.trapezium.vizwiz.command;

public class Command implements VizCommands {
    // allowable formats for incoming data
    static final public int BYTE_FORMAT = 1;
    static final public int INT_FORMAT = 2;
    
    static public String toString( int[] command ) {
        if ( command == null ) {
            return( "null" );
        }
        
        switch ( command[1] ) {
        case MAIN_CALIBRATION:
            return( "MAIN_CALIBRATION" );
        case MAIN_DATA:
            return( "MAIN_DATA" );
        case TRANSFORMER_DATA:
            return( "TRANSFORMER_DATA" );
        case FORMAT_VERSION:
            return( "FORMAT_VERSION" );
        case LOCATION_RANGES:
            return( "LOCATION_RANGES" );
        case SIGNAL_RANGES:
            return( "SIGNAL_RANGES" );
        case LOCATION_INDICATOR:
            return( "LOCATION_INDICATOR" );
        case SIGNAL_INDICATOR:
            return( "SIGNAL_INDICATOR" );
        case TIME_MARKER:
            return( "TIME_MARKER" );
        case PAUSE_MARKER:
            return( "PAUSE_MARKER" );
        case REGISTER_COLLISION:
            return( "REGISTER_COLLISION" );
        case REGISTER_TIMEOUT:
            return( "REGISTER_TIMEOUT" );
        case OBJECT_LOCATION:
            return( "OBJECT_LOCATION" );
        case OBJECT_ORIENTATION:
            return( "OBJECT_ORIENTATION" );
        case OBJECT_EMISSIVE_COLOR:
            return( "OBJECT_EMISSIVE_COLOR" );
        case OBJECT_DIFFUSE_COLOR:
            return( "OBJECT_DIFFUSE_COLOR" );
        case OBJECT_SCALE:
            return( "OBJECT_SCALE" );
        case OBJECT_TRANSPARENCY:
            return( "OBJECT_TRANSPARENCY" );
        case OBJECT_MARKER:
            return( "OBJECT_MARKER" );
        default:
            return( "*** UNKNOWN ***" );
        }
    }
    
    static public long decodeTime( int[] timeInfo ) {
        long result = timeInfo[2];
        result = (result << 32);
        result += timeInfo[3];
        return( result );
    }
}