package com.trapezium.vizwiz.command;

public class SkipWriter extends CommandWriter {
    
    int commandToSkip;
    int skipCount;
    int currentCount;
    
    public SkipWriter( CommandWriter cw, int commandToSkip ) {
        super( cw );
        this.commandToSkip = commandToSkip;
    }
    
    public SkipWriter( CommandWriter cw, int commandToSkip, int skipCount ) {
        super( cw );
        this.commandToSkip = commandToSkip;
        this.skipCount = skipCount;
        currentCount = 0;
    }
    
    public void writeCommand( int[] command ) {
        if ( command[0] != commandToSkip ) {
            super.writeCommand( command );
        } else if ( skipCount > 0 ) {
            currentCount++;
            if ( currentCount == skipCount ) {
                super.writeCommand( command );
                currentCount = 0;
            }
        }
    }
}