package com.trapezium.vizwiz.command;

public class TimeInjector extends CommandWriter implements VizCommands {
    
    int[] timeMark;
    
    public TimeInjector( CommandWriter cw ) {
        super( cw );
        timeMark = new int[4];
        timeMark[1] = Command.TIME_MARKER;
    }
    
    public void writeCommand( int[] command ) {
        if (( command[1] == Command.LOCATION_INDICATOR ) || (( command[1] >= OBJECT_LOCATION ) && ( command[1] < OBJECT_MARKER ))) {
            timeMark[0] = command[0];
            long milliTime = System.currentTimeMillis();
            timeMark[3] = (int)(milliTime & 0xffff);
            milliTime = (milliTime >> 32);
            timeMark[2] = (int)(milliTime & 0xffff);
            super.writeCommand( timeMark );
        }
        super.writeCommand( command );
    }
}
        
        