package com.trapezium.vizwiz.command;

public interface VizCommands {
    // incoming commands from neattools, must correspond exactly with VizCommands.h
    // header file used with neattools
    static final int MAIN_CALIBRATION = 1;
    static final int MAIN_DATA = 2;
    static final int TRANSFORMER_DATA = 4;
    static final int FILE_LOAD_REQUEST = 5;
       
    // Viz specific data injected into stream
    static final int FORMAT_VERSION = 1000;    // format of data recording
    static final int LOCATION_RANGES = 1001;   // range of locations     
    static final int SIGNAL_RANGES = 1002;     // range of signals
        
    static final int LOCATION_INDICATOR = 1003;// indicates location info is following
    static final int SIGNAL_INDICATOR = 1004;  // indicates signal info is following
    static final int OBJECT_LOCATION = 1005;   // locate a particular object
    static final int OBJECT_ORIENTATION = 1006;// orient an object
    static final int OBJECT_EMISSIVE_COLOR = 1007; // set object's emissive color
    static final int OBJECT_DIFFUSE_COLOR = 1008;  // set object's diffuse color
    static final int OBJECT_SCALE = 1009;      // set object's scale
    static final int OBJECT_TRANSPARENCY = 1010; // set object's transparency
    static final int OBJECT_MARKER = 1011;      // not yet implemented... zoom to origin?
       
    static final int TIME_MARKER = 2000;       // time stamp marker
    static final int PAUSE_MARKER = 2001;      // pause-until-interrupted marker (for playback)
    static final int REGISTER_COLLISION = 2002;// register collision information on playback
    static final int REGISTER_TIMEOUT = 2003;  // register timeout information on playback

}