/*
 * @(#)ISLocatorFactory.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */
package com.trapezium.vrml.visitor;

import com.trapezium.pattern.Visitor;
import com.trapezium.vrml.fields.ISField;

/**
 *  A factory that always returns a "reset" version of a singleton
 *  ISLocator.  Optimization to avoid unnecessary creation/destruction
 *  of an ISLocator which gets used quite a bit during PROTO realization.
 */
public class ISLocatorFactory {
    static ISLocator isLocator = null;

    static public ISLocator get() {
        if ( isLocator == null ) {
            isLocator = new ISLocator();
        }
        isLocator.reset();
        return( isLocator );
    }
}
