/*
 * @(#)BaseNode.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */

package vrml;

import java.util.Hashtable;

public abstract class BaseNode {

    protected com.trapezium.vrml.node.Node node;

    public BaseNode() {
//        System.out.println("====BaseNode()");
    }

    public void setNode(com.trapezium.vrml.node.Node node) {
//        System.out.println("====BaseNode.setNode()");
    	this.node = node;
    	node.setBaseNode(this);
    }


    /** Returns the type of the node.  If the node is a prototype
     *  it returns the name of the prototype.
     */
    public String getType() {
        return node.getNodeName();
    }


    /** Get the Browser that this node is contained in.
     */
    public Browser getBrowser() {
        return node.getBrowser();
    }

    /** Get the implementation for this node */
    public com.trapezium.vrml.node.Node getNode() {
        return node;
    }
}
