/*
 *      @(#)MFFloat.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */


package vrml.field;

import com.trapezium.browser.vrml.node.RuntimeField;

public class MFFloat extends vrml.MField {

    public MFFloat(RuntimeField rf) {
    	super(rf);
    }

    public MFFloat(int size, float values[]) {
    	super( RuntimeField.createRuntimeField( (size < values.length) ? (new float[0]) : values ) );

        if (size < values.length) {
            float[] floats = new float[size];
            System.arraycopy(values, 0, floats, 0, size);
            setValue(floats);
        }
    }
    
    public MFFloat(float values[]) {
    	super(RuntimeField.createRuntimeField(values));
    }

   
    public void setValue(ConstMFFloat f) {
    	setValue(f.getFloatArray());
    }

    public void setValue(MFFloat f) {
    	setValue(f.getFloatArray());
    }

    public float get1Value(int index) {
    	return get1FloatValue( index);
    }

    public void set1Value(int index, ConstSFFloat f) {
    	set1Value( index, f.getFloatValue());
    }

    public void set1Value(int index, SFFloat f) {
    	set1Value( index, f.getFloatValue());
    }

   
    public void addValue(ConstSFFloat f) {
    	addValue( f.getFloatValue() );
    }

    public void addValue(SFFloat f) {
    	addValue( f.getFloatValue() );
    }

    public void insertValue( int index, ConstSFFloat f ) {
    	insertValue( index, f.getFloatValue() );
    }

    public void insertValue( int index, SFFloat f ) {
    	insertValue( index, f.getFloatValue() );
    }				

}
