/*
 * @(#)MFInt32.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */


package vrml.field;

import com.trapezium.browser.vrml.node.RuntimeField;

public class MFInt32 extends vrml.MField {

    public MFInt32(RuntimeField rf) {
    	super(rf);
    }

    public MFInt32(int size, int values[]) {
    	super( RuntimeField.createRuntimeField( (size < values.length) ? (new int[0]) : values ) );

        if (size < values.length) {
            int[] ints = new int[size];
            System.arraycopy(values, 0, ints, 0, size);
            setValue(ints);
        }
    }
    
    public MFInt32(int values[]) {
    	super(RuntimeField.createRuntimeField(values));
    }

   
    public void setValue(ConstMFInt32 f) {
    	setValue(f.getIntArray());
    }

    public void setValue(MFInt32 f) {
    	setValue(f.getIntArray());
    }

    public int get1Value(int index) {
    	return get1IntValue( index);
    }

    public void set1Value(int index, ConstSFInt32 f) {
    	set1Value( index, f.getIntValue());
    }

    public void set1Value(int index, SFInt32 f) {
    	set1Value( index, f.getIntValue());
    }

   
    public void addValue(ConstSFInt32 f) {
    	addValue( f.getIntValue() );
    }

    public void addValue(SFInt32 f) {
    	addValue( f.getIntValue() );
    }

    public void insertValue( int index, ConstSFInt32 f ) {
    	insertValue( index, f.getIntValue() );
    }

    public void insertValue( int index, SFInt32 f ) {
    	insertValue( index, f.getIntValue() );
    }				
	
}
