/*
 * @(#)MFVec2f.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */

package vrml.field;

import com.trapezium.browser.vrml.node.RuntimeField;

public class MFVec2f extends vrml.MField {	

    public MFVec2f(RuntimeField rf) {
    	super(rf);
    }

    public MFVec2f(float[][] values) {
    	super(RuntimeField.createRuntimeField(values));
    }

    public MFVec2f(float[] values) {
    	super(RuntimeField.createRuntimeField(values, 2));
    }

    public void get1Value(int index, SFVec2f vec) {
        float[] f = new float[3];
	    get1Value(index, f);
	    vec.setValue(f);
    }

    public void setValue(ConstMFVec2f vec) {
	    setValue(vec.getTupleArray());
    }

    public void set1Value(int index, ConstSFVec2f constvec) {
        set1Value(index, constvec.getFloatArray());
    }

    public void set1Value(int index, SFVec2f vec) {
        set1Value(index, vec.getFloatArray());
    } 
    

    public void insertValue(int index, ConstSFVec2f constvec) {
	    insertValue(index, constvec.getFloatArray());
    }

    public void insertValue(int index, SFVec2f vec) {
	    insertValue(index, vec.getFloatArray());
    }
}
