/*
 * @(#)SFColor.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */


package vrml.field;

import com.trapezium.browser.vrml.node.RuntimeField;

public class SFColor extends vrml.Field {

    public SFColor(RuntimeField rf) {
	    super(rf);
    }

    public SFColor(float red, float green, float blue) {
    	super(RuntimeField.createRuntimeField(red, green, blue));
    }

    public SFColor(float[] color) {
    	super(RuntimeField.createRuntimeField(color));
    }

    public float[] getValue() {
	    return getFloatArray();
    }
		    
    public void setRed(float red) {
    	set1Value(0, red);
    }

    public void setGreen(float green) {
    	set1Value(1, green);
    }

    public void setBlue(float blue) {
    	set1Value(2, blue);
    }

    public float getRed() {
        return get1FloatValue(0);
    }

    public float getGreen() {
        return get1FloatValue(1);
    }

    public float getBlue() {
        return get1FloatValue(2);
    }


    public void setValue( ConstSFColor constsfcolr ) {
    	setValue(3, constsfcolr.getFloatArray());
    }

    public void setValue( SFColor sfcolr ) {
    	setValue(3, sfcolr.getFloatArray());
    }

}
