/*
 * @(#)SFImage.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */


package vrml.field;

import com.trapezium.browser.vrml.node.RuntimeField;

public class SFImage extends vrml.Field {

    
    public SFImage(RuntimeField rf) {
    	super(rf);
    }

    public SFImage(int w, int h, int d, byte[] p) {
    	super(RuntimeField.createRuntimeField(new ImageInfo(w, h, d, p)));
    }

    public int getWidth() {
        return ((ImageInfo) getObject()).w;
    }
    public int getHeight() {
        return ((ImageInfo) getObject()).w;
    }
    
    public int getComponents() {
        return ((ImageInfo) getObject()).d;
    }
    
    public void getPixels(byte[] p){
        byte[] pixels = ((ImageInfo) getObject()).p;
        System.arraycopy(pixels, 0, p, 0, Math.min(pixels.length, p.length));
    }

    public void setValue(int w, int h, int d, byte[] p) {
        setValue(new ImageInfo(w, h, d, p));
    }

    public void setValue(ConstSFImage i) {
        setValue(i.getObject());
    }

    public void setValue(SFImage i) {
        setValue(i.getObject());
    }
    
}

class ImageInfo {
    int w;
    int h;
    int d;
    byte[] p;
    public ImageInfo(int w, int h, int d, byte[] p) {
        this.w = w;
        this.h = h;
        this.d = d;
        this.p = p;
    }
}
