/*
 * @(#)SFVec3f.java
 *
 * Copyright (c) 1999 by Trapezium Development LLC.  All Rights Reserved.
 *
 * The information in this file is the property of Trapezium Development LLC
 * and may be used only in accordance with the terms of the license granted
 * by Trapezium.
 *
 */


package vrml.field;

import com.trapezium.browser.vrml.node.RuntimeField;

public class SFVec3f extends vrml.Field {

    public SFVec3f(RuntimeField rf) {
	    super(rf);
    }
    public SFVec3f(float[] values) {
    	super(RuntimeField.createRuntimeField(values));
    }

    public SFVec3f(float x, float y, float z) {
    	super(RuntimeField.createRuntimeField(x, y, z));
    }


    public float[] getValue() {
    	return getFloatArray();
    }

    public float getX() {
    	return get1FloatValue(0);
    }

    public float getY() {
    	return get1FloatValue(1);
    }

    public float getZ() {
    	return get1FloatValue(2);
    }


    public void setValue(ConstSFVec3f v) {
    	setValue(v.getFloatArray());
    }

    public void setValue(SFVec3f v) {
    	setValue(v.getFloatArray());
    }
	
}
