package mindtel.pdb.graph;

import mindtel.pdb.parse.tngpdb;
import mindtel.pdb.graph.StreamDisplay;
import java.awt.*;
import java.awt.event.*;
import mindtel.DemoPanel;
import java.io.FileReader;
import java.io.LineNumberReader;


public class PDBgraph {
    
        /* java 1.4 FINALLY gets the String.split method, 1.3 does not have it */
    static ChannelData createChannelData( ChannelData channelData, String line ) {
        if ( channelData == null ) {
            int valueCount = 1;
            for ( int i = 0; i < line.length(); i++ ) {
                if ( line.charAt( i ) == ',' ) {
                    valueCount++;
                }
            }
            channelData = new ChannelData( valueCount );
        }
        channelData.store( line );
        return( channelData );
    }

    public static void main(String argv[]) {
        if ( argv.length == 0 ) {
            System.out.println("Missing name of comma separated value file to graph.");
            System.exit(0);
        }
        String dataFile = argv[0];
        tngpdb data = new tngpdb( dataFile );
        ChannelData channelData = new ChannelData();
        int nchannels = data.getNumberChannels( 0 );
        //System.out.println("nchannels is " + nchannels);
        channelData.init( nchannels );
        for ( int i = 0; i < data.getNumberRecords(); i++ ) {
            channelData.storeTime( new Integer( data.getTime( i )));
            for ( int j = 0; j < nchannels; j++ ) {
                channelData.storeData( j, new Integer( data.getDataValue( i, j )));
            }
        }
        
        final DemoPanel dp = new DemoPanel(new StreamDisplay(channelData));
        Frame f = new Frame("PDB Grapher");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
            public void windowDeiconified(WindowEvent e) { 
                dp.surface.start(); 
            }
            public void windowIconified(WindowEvent e) { 
                dp.surface.stop(); 
            }
        });
        f.add("Center", dp);
        f.pack();
        f.setSize(new Dimension(800,75*channelData.getNumberChannels()));
        f.show();
        dp.surface.start();
    }
}