package mindtel.pdb.graph;

import mindtel.pdb.graph.StreamDisplay;
import java.awt.*;
import java.awt.event.*;
import mindtel.DemoPanel;
import java.io.FileReader;
import java.io.LineNumberReader;


public class TNGgraph {
    
        /* java 1.4 FINALLY gets the String.split method, 1.3 does not have it */
    static ChannelData createChannelData( ChannelData channelData, String line ) {
        if ( channelData == null ) {
            int valueCount = 1;
            for ( int i = 0; i < line.length(); i++ ) {
                if ( line.charAt( i ) == ',' ) {
                    valueCount++;
                }
            }
            channelData = new ChannelData( valueCount );
        }
        channelData.store( line );
        return( channelData );
    }

    public static void main(String argv[]) {
        if ( argv.length == 0 ) {
            System.out.println("Missing name of comma separated value file to graph.");
            System.exit(0);
        }
        String csvFile = argv[0];
        ChannelData channelData = null;
        try {
            LineNumberReader is = new LineNumberReader( new FileReader( csvFile ));
            String text;
            while (( text = is.readLine()) != null ) {
                System.out.println("Line: " + text );
                channelData = createChannelData( channelData, text );
            }
        } catch ( java.io.IOException e ) {
        }
        channelData.dump();
        
        final DemoPanel dp = new DemoPanel(new StreamDisplay(channelData));
        Frame f = new Frame("PDB Grapher");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
            public void windowDeiconified(WindowEvent e) { 
                dp.surface.start(); 
            }
            public void windowIconified(WindowEvent e) { 
                dp.surface.stop(); 
            }
        });
        f.add("Center", dp);
        f.pack();
        f.setSize(new Dimension(800,75*channelData.getNumberChannels()));
        f.show();
        dp.surface.start();
    }
}
