#
#  This is a really simple thing for extracting the non-water
#  elevation entries from the 56Mb USGS data files.
#
#  Water entries are encoded as -9999
#
#  The results are a set of lines each containing:  row col elevation
#
def readval(file):
  b1 = file.read(1)
  b2 = file.read(1)
  result = (ord(b1)<<8) + ord(b2)
  if result>32768:
    result = result - 65536
    return result
  else:
    return result

def processrow(rowno,row):
  rlen = len(row)
  if rlen!=9600:
    print "Hey"
  else:
    for x in range(0,9600,2):
      result = (ord(row[x])<<8) + ord(row[x+1])
      if result > 32768:
        result = result - 65536
      if result != -9999:
        col = x/2
        print "%d %d %d" % (rowno,col,result)

def readrow(rowno,file):
  row = file.read(9600)
  processrow(rowno,row)

file = open("f:/W180N40/W180N40.dem","rb")
for x in range(6000):
  readrow(x,file)
readrow(6000,file)
